%% @author Luiz Carlos
%% @doc @todo Add description to main.


-module(main).
-export([start/0]).
	
-record(pedido, {cliente = clientes, numero = numero,valor = valor, entregador = entregado ,placa = placa , data = data}).

-record(lanche, {nome = "_", valor = "_", var = "_"}).

-record(entregador, {nome = "_", placa = "_", status = livre }).

-record(pessoa, {nome = "_", numero = "_"}).

start() ->
%--------------------LE ARQUIVO DE CLIENTES E INICIALIZA LISTA DE CLIENTES-------------------	
NomeArquivoCliente = "InicializaClientes.txt",
ListaCliente = #pessoa{},
StringCliente = inicializa:inicializaClientes(NomeArquivoCliente),
X1 = erlang:size(StringCliente),
ClientesTupla = inicializa:listaClientes(X1, StringCliente, ListaCliente),
RemovC1 = lists:delete(pessoa, ClientesTupla),
RemovC2 = lists:delete("_", RemovC1),
Clientes = lists:delete("_",RemovC2),

%-------------------LE ARQUIVO DE CLIENTES E INICIALIZA LISTA DE ENTREGADORES----------------
	
NomeArquivoEntregador = "InicializaEntregadores.txt",
ListaEntregador = #pessoa{},
StringEntregador = inicializa:inicializaEntregadores(NomeArquivoEntregador),
X2 = erlang:size(StringEntregador),
EntregadoresTupla = inicializa:listaEntregadores(X2, StringEntregador, ListaEntregador),
RemovE1 = lists:delete(entregador, EntregadoresTupla),
RemovE2 = lists:delete("_", RemovE1),
RemovE3 = lists:delete("_",RemovE2),
Entregadores = lists:delete(livre,RemovE3),


%-------------------LE ARQUIVO DE CLIENTES E INICIALIZA LISTA DE LANCHES----------------

NomeArquivoLanches = "InicializaLanches.txt",
ListaLanches = #lanche{},
StringLanches = inicializa:inicializaLanches(NomeArquivoLanches),
X3 = erlang:size(StringLanches),
LanchesTupla = inicializa:listaLanches(X3, StringLanches, ListaLanches),
RemovL1 = lists:delete(entregador, LanchesTupla),
RemovL2 = lists:delete("_", RemovL1),
RemovL3 = lists:delete("_",RemovL2),
Lanches = lists:delete("_",RemovL3),


Entregadores1 = entregador:addEntregador(joaquim, "XYZ-123", Entregadores),
Entregadores2 = entregador:removeEntregador(joaquim, Entregadores1),
%ADICIONANDO E REMOVENDO ENTREGADORES DA LISTA

Clientes1 = cliente:addCliente("fernando", 99092901, Clientes),
Clientes2 = cliente:removeCliente("fernando", Clientes1),
%ADICIONANDO E REMOVENDO CLIENTES DA LISTA

Lanches1 = lanche:addLanche("frango com fritas", 25, "X", Lanches),
Lanches2 = lanche:removeLanche("frango com fritas", Lanches1),
%ADICIONANDO E REMOVENDO LANCHES DA LISTA

ListaPedidos = #pedido{},
%INICIALIZANDO LISTA DE PEDIDOS(VALORES DEFAULT)

Valor = 0,
%INICIALIZANDO VALOR INICIAL DA RECURSAO DO PEDIDO = 0

Cliente1 = joselito,
Pedido1 = {xbacon,refri},
%RETORNA O TAMANHO DA LISTA DO PEDIDO
PedidoEfetuado1 = pedido:realizaPedido(erlang:size(Pedido1), Valor, Pedido1, Lanches, Cliente1, Clientes, Entregadores),
ListaPedidos1 = erlang:append_element(ListaPedidos, PedidoEfetuado1),
%INFORMAR NOME DO CLIENTE, O PEDIDO E REALIZAR A CONTA TOTAL QUE SERA GASTO (Entregadores sAo selecionados automaticamente de acordo com o status)

Cliente2 = pedro,
Pedido2 = {xbacon,agua},
%RETORNA O TAMANHO DA LISTA DO PEDIDO
PedidoEfetuado2 = pedido:realizaPedido(erlang:size(Pedido2), Valor, Pedido2, Lanches, Cliente2, Clientes, Entregadores),
ListaPedidos2 = erlang:append_element(ListaPedidos1, PedidoEfetuado2),


Cliente3 = joao,
Pedido3 = {salada,agua},
erlang:size(Pedido3),
%RETORNA O TAMANHO DA LISTA DO PEDIDO
PedidoEfetuado3 = pedido:realizaPedido(erlang:size(Pedido3), Valor, Pedido3, Lanches, Cliente3, Clientes, Entregadores),
ListaPedidos3 = erlang:append_element(ListaPedidos2, PedidoEfetuado3),

file:write_file("relatorio.txt", io_lib:fwrite("~p~n",[ListaPedidos3])).


%IMPRIME TODOS PEDIDOS NO ARQUIVO
