%% @author Luiz Carlos
%% @doc @todo Add description to pedido.


-module(pedido).


-export([realizaPedido/7]).



%-record(pedido, {cliente = "clientes;numero", lanche = "valor;", entregador = "entregador;placa;data;", data = erlang:date()}).

-record(pedido, {cliente = "clientes;", numero = ";numero",valor = "valor;", entregador = "entregador",placa = "placa;data;", data = erlang:date()}).

-record(lanche, {nome = "_", valor = "_", var = "_"}).

-record(entregador, {nome = "_", placa = "_", status = livre }).

-record(pessoa, {nome = "_", numero = "_"}).


realizaPedido(X,Valor,Pedido,Lanches,Cliente,Clientes,Entregadores) when X > 0 ->
	%REALIZA BUSCA DO PEDIDO DO CLIENTE COM A LISTA DE LANCHES, SE TIVER O LANCHE SOMA O VALOR SENAO IGNORA. SAIDA: PEDIDO COM TODOS OS DADOS
	NomeLanche = erlang:element(X,Pedido),
	Y = lists:keymember(NomeLanche,#lanche.nome,Lanches),
	if
		Y == true ->
	Lanche = lists:keysearch(NomeLanche,#lanche.nome,Lanches),
	RetornaRecordLanche = erlang:element(2,Lanche),
	Valor1 = Valor + RetornaRecordLanche#lanche.valor;
		true ->
	Valor1 = Valor
	end,
	
	realizaPedido(X-1,Valor1,Pedido,Lanches,Cliente,Clientes,Entregadores);
	realizaPedido(0,Valor,Pedido,Lanches,Cliente,Clientes,Entregadores) ->
	Valor,
		Entregador = lists:keysearch(livre,#entregador.status,Entregadores),
		RetornaRecordEntregador = erlang:element(2,Entregador),
		Pessoa = lists:keysearch(Cliente,#entregador.nome,Clientes),
		RetornaRecordPessoa = erlang:element(2,Pessoa),
		#pedido{cliente = RetornaRecordPessoa#pessoa.nome, numero = RetornaRecordPessoa#pessoa.numero, valor = Valor, entregador = RetornaRecordEntregador#entregador.nome, placa = RetornaRecordEntregador#entregador.placa, data = erlang:date()}.


