%% @author Luiz Carlos
%% @doc @todo Add description to cliente.


-module(cliente).

%% ====================================================================
%% API functions
%% ====================================================================
-export([removeCliente/2,addCliente/3]).

-record(pessoa, {nome = "_", numero = "_"}).

removeCliente(Nome,Clientes) ->
	Pessoa = lists:keysearch(Nome,#pessoa.nome,Clientes),
	RetornaRecordClientes = erlang:element(2,Pessoa),
	lists:delete(RetornaRecordClientes,Clientes).

addCliente(Nome,Numero,Clientes) ->
	Pessoa = #pessoa{nome = Nome, numero = Numero},
	ClientesTupla = erlang:list_to_tuple(Clientes),
	TuplaAtualizada = erlang:append_element(ClientesTupla,Pessoa),
	erlang:tuple_to_list(TuplaAtualizada). %Algumas operaes no sao aceitas para manipular lista por isso  necessario converter para tupla, fazer a atualizao e converter novamente para lista

%% ====================================================================
%% Internal functions
%% ====================================================================


