%% @author Luiz Carlos
%% @doc @todo Add description to entregador.


-module(entregador).

%% ====================================================================
%% API functions
%% ====================================================================
-export([removeEntregador/2,addEntregador/3]).
-record(entregador, {nome = "_", placa = "_", status = livre }).

removeEntregador(Nome,Entregadores) ->
	Pessoa = lists:keysearch(Nome,#entregador.nome,Entregadores),
	RetornaRecordEntregador = erlang:element(2,Pessoa),
	lists:delete(RetornaRecordEntregador,Entregadores).

addEntregador(Nome,Placa,Entregadores) ->
	Pessoa = #entregador{nome = Nome, placa = Placa, status = livre},
	EntregadoresTupla = erlang:list_to_tuple(Entregadores),
	TuplaAtualizada = erlang:append_element(EntregadoresTupla,Pessoa),
	erlang:tuple_to_list(TuplaAtualizada).
%% ====================================================================
%% Internal functions
%% ====================================================================


