%% @author Luiz Carlos
%% @doc @todo Add description to lanche.


-module(lanche).


-export([addLanche/4,removeLanche/2]).

-record(lanche, {nome = "_", valor = "_", var = "_"}).


removeLanche(Nome,Lanches) ->
	Lanche = lists:keysearch(Nome,#lanche.nome,Lanches),
	RetornaRecordLanches = erlang:element(2,Lanche),
	lists:delete(RetornaRecordLanches,Lanches).

addLanche(Nome,Valor,Var,Lanches) ->
	Lanche = #lanche{nome = Nome, valor = Valor, var = Var},
	LanchesTupla = erlang:list_to_tuple(Lanches),
	TuplaAtualizada = erlang:append_element(LanchesTupla,Lanche),
	erlang:tuple_to_list(TuplaAtualizada).
